Option Explicit

' **************************************************************** 
' **************************************************************** 
' *** 
' *** 
' *** WeaponPositionModifier (WPM) - BETA VERSION - Freeware 
' ***
' *** This program can be used to increase or decrease the height
' *** or width of a shield (by changing the shield parameter 
' *** numbers and/or moving the origin).
' *** 
' *** This simple utility is provided as freeware so feel free to 
' *** change/copy/amend or whatever (but please don't come to me if
' *** you chnage it and it no longer works correctly!) 
' ***
' ***Based on WPM freeware written by Wellington - Jan/Feb 2003  
' ***Amended by Olorin
' ****************************************************************
' **************************************************************** 

' *** 
' *** Naming conventions 
' ***

Dim OurPath, CopyPath, MyFile, Index, fso, NormShield
Dim  TLx,   TLy,   BLx,   BLy,   TRx,   TRy,   BRx,   BRy,  WPMod
Dim mTLx,  mTLy,  mBLx,  mBLy,  mTRx,  mTRy,  mBRx,  mBRy, mWPMod
Dim mTLx1, mTLy1, mBLx1, mBLy1, mTRx1, mTRy1, mBRx1, mBRy1
Dim mTLx2, mTLy2, mBLx2, mBLy2, mTRx2, mTRy2, mBRx2, mBRy2
Dim TxtFileArray, CurrentLine, CurrentFile, CurrentKey  
Dim OriginDic, FileDic, ParmsDic
Dim Allkeys, Allitems, onekey, oneitem
Dim fso2, testfile

Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const OneSpace = " ", TwoSpace = "  ", PercSign = "%"
Const ID_Increase = 0, ID_Decrease = 1


  Set fso2 = CreateObject("Scripting.FileSystemObject") 

  OurPath = GetLocalDirectory()  

  Set fso = CreateObject("Scripting.FileSystemObject") 
  Set FileDic = CreateObject("Scripting.Dictionary")
  Set ParmsDic = CreateObject("Scripting.Dictionary")
  Set OriginDic = CreateObject("Scripting.Dictionary")

  If (fso.FileExists(OurPath & "WeaponModifiers.txt")) Then
    fso.DeleteFile(OurPath & "WeaponModifiers.txt")
  End If  
  Set TestFile = fso2.OpenTextFile(OurPath & "WeaponModifiers.txt", ForAppending, True)

  Call ReadWeaponParms(Ourpath, "WeaponParms.txt")
  Call CopyAllFiles(Ourpath, CopyPath)  
  Call ChangeFilePositions() 

  TestFile.Close 
  
  Set FileDic = Nothing
  Set ParmsDic = Nothing
  Set OriginDic = Nothing
  Set fso = Nothing

  MsgBox "Finished!"

' ********************************************************************************
' ***
' ***  first copy all files from the backup ('CopyFrom=' parameter) folder
' ***
' ******************************************************************************** 


Sub CopyAllFiles(topath, frompath) 
  Dim i, temp, filename 
  Allitems = FileDic.Items  
  Allkeys  = FileDic.Keys  
  For i = 0 To FileDic.Count -1 
    filename = Allkeys(i)   
    fso.CopyFile frompath & "\" & filename, topath 
  Next
End Sub 


' ******************************************************************************** 
' ***
' ***  change the positions for each file and each camera angle in each file
' ***
' ******************************************************************************** 


Sub ChangeFilePositions() 
  Dim i, temp, count, parms   
  
  Allitems = FileDic.Items  
  Allkeys  = FileDic.Keys  
  For i = 0 To FileDic.Count -1 
    CurrentFile = Allkeys(i) 

    Call ReadPositionsFile(Ourpath, CurrentFile)
   
    Call ProcessCameraAngle(1,1,12)               ' camera angle 1 - 1st 12 lines  
    Call ProcessCameraAngle(2,13,24)              ' camera angle 2 - 2nd 12 lines  
    Call ProcessCameraAngle(3,25,36)              ' camera angle 3 - 3rd 12 lines 
    Call ProcessCameraAngle(4,37,48)              ' camera angle 4 - 4th 12 lines   

    Call WritePositionsFile(Ourpath, CurrentFile)
  Next

End Sub

' ***
' *** process all 12 lines for a specific camera angle
' ***

Sub ProcessCameraAngle(ca, fromline, toline) 
  CurrentKey = CurrentFile & "," & ca
  For Index = fromline to toline              
    Call GetNextLine(Index)
    If (ParmsDic.Exists(CurrentKey)) Then      
      Call AmendLine(ParmsDic.Item(CurrentKey))
    End If     
    Call PutNextLine(Index)
  Next 
  Call WriteXrefFile(CurrentKey)
End Sub
 
' ***
' *** Get the next line in the array of weapon positions
' ***

Sub GetNextLine(num)
  Dim temp, i, parms
  CurrentLine = TxtFileArray(num - 1)
  temp = Split(TxtFileArray(num - 1), OneSpace)
  TLx = temp(0)
  TLy = temp(1)
  'TRx = temp(0)
  'TRy = temp(1)
  'BLx = temp(2)
  'BLy = temp(3)  
  BRx = temp(2)
  BRy = temp(3)
  WPMod = temp(4)

'  If (NormShield) Then               ' do we want to normalise the shield shape?    
 '   Call AmendShieldShape()
 ' End If     
  
  If (OriginDic.Exists(CurrentKey)) Then   ' do we want to change an origin ?
    parms = OriginDic.Item(CurrentKey)   
    Call AmendOrigins(parms)
  End If      
  
  mTLx = TLx
  mTLy = TLy
'  mTRx = TRx
'  mTRy = TRy
'  mBLx = BLx
'  mBLy = BLy  
  mBRx = BRx
  mBRy = BRy 
  mWPMod = WPMod 
End Sub

' ***
' *** put the amended line back into the array
' ***

Sub PutNextLine(num)
  Dim temp, i
  temp =         mTLx & OneSpace & mTLy & OneSpace 
'& mTRx & OneSpace & mTRy & OneSpace 
  temp = temp  & mBRx & OneSpace & mBRy & OneSpace & mWPMod  
'& mBLx & OneSpace & mBLy & OneSpace 
  TxtFileArray(num - 1) = temp 
End Sub

' ***
' *** write the Xref (just so I know what's been changed - only for debugging really)
' ***

Sub WriteXrefFile(parms) 
  Dim z, temp
  temp = Split(parms, ",")
  z = "FileCam=(" & temp(0) & "," & temp(1) & ")"  
  z = Left(z & "            ", 25) & vbtab
  z = z & "mTLy = " &  mTLy1 & "  " &  mTLy2 & vbtab
  'z = z & "mTRy = " &  mTRy1 & "  " &  mTRy2 & vbtab
  z = z & "mTLx = " &  mTLx1 & "  " &  mTLx2 & vbtab
  'z = z & "mTRx = " &  mTRx1 & "  " &  mTRx2 & vbtab
  'z = z & "mBLy = " &  mBLy1 & "  " &  mBLy2 & vbtab  
  z = z & "mBRy = " &  mBRy1 & "  " &  mBRy2 & vbtab  
  'z = z & "mBLx = " &  mBLx1 & "  " &  mBLx2 & vbtab  
  z = z & "mBRx = " &  mBRx1 & "  " &  mBRx2 & vbtab 
  TestFile.WriteLine  z & "   Weapon=" & mWPMod 
End Sub


' ******************************************************************************** 
' ***
' *** The shield type amendment routine 
' ***
' ******************************************************************************** 


'Sub AmendShieldShape()
'  Dim top, bottom, left, right  
'
'  top    = TRx - TLx 
'  bottom = BRx - BLx
'  left   = BLy - TLy
'  right  = BRy - TRy
'   
'  If (Abs(top) <> Abs(bottom)) Then
'    If (Abs(top) > Abs(bottom)) Then
'      BLx = BLx - (top - bottom)
'    Else
'      TLx = TLx - (bottom - top)
'    End If   
'  End If
'  If (Abs(left) <> Abs(right)) Then
'    If (Abs(left) > Abs(right)) Then
'      TRy = TRy - (left - right)
'    Else
'      TLy = TLy - (right - left)
'    End If   
'  End If
'
'End Sub


' ******************************************************************************** 
' ***
' *** The origin amendment routine 
' ***
' ******************************************************************************** 


Sub AmendOrigins(parms)
  Dim temp
  temp = Split(parms, ",")
  temp(0) = Int(temp(0))
  temp(1) = Int(temp(1))
  temp(2) = Int(temp(2))
  temp(3) = Int(temp(3))
  If (temp(0) <> 0) Then             ' up    
    TLy = TLy - temp(0)    
    'TRy = TRy - temp(0)  
    'BLy = BLy - temp(0)   
    BRy = BRy - temp(0) 
  End If
  If (temp(1) <> 0) Then             ' down
    TLy = TLy + temp(1)    
    'TRy = TRy + temp(1)  
    'BLy = BLy + temp(1)   
    BRy = BRy + temp(1) 
  End If
  If (temp(2) <> 0) Then             ' left
    TLx = TLx - temp(2)    
    'TRx = TRx - temp(2)  
    'BLx = BLx - temp(2)   
    BRx = BRx - temp(2) 
  End If
  If (temp(3) <> 0) Then             ' right
    TLx = TLx + temp(3)    
    'TRx = TRx + temp(3)  
    'BLx = BLx + temp(3)   
    BRx = BRx + temp(3) 
  End If
End Sub


' ******************************************************************************** 
' ***
' *** The shield position amendment routines 
' ***
' ******************************************************************************** 

'          TLy          TRy 
'           A            A
'     TLx < ************** > TRx
'           *            *
'           *            *
'           *            *
'           *            *
'           *            *
'           *            *
'           *            *
'           *            *
'     BLx < ************** > BRx
'           V            V
'          BLy          BRy  


Sub AmendLine(parms)
  Dim p, i
  mTLy1 = 0
  mTRy1 = 0
  mTLx1 = 0
  mTRx1 = 0
  mBLy1 = 0 
  mBRy1 = 0
  mBLx1 = 0
  mBRx1 = 0 
  mTLy2 = 0
  mTRy2 = 0
  mTLx2 = 0
  mTRx2 = 0
  mBLy2 = 0 
  mBRy2 = 0
  mBLx2 = 0
  mBRx2 = 0 
  
  p = Split(parms, ",")

  If (p(0) <> 0) Then Call ModifyTop(p(0), ID_Increase) 
  If (p(2) <> 0) Then Call ModifyLeft(p(2), ID_Increase)  
  If (p(4) <> 0) Then Call ModifyRight(p(4), ID_Increase)  
  If (p(6) <> 0) Then Call ModifyBottom(p(6), ID_Increase) 

  If (p(1) <> 0) Then Call ModifyTop(p(1), ID_Decrease) 
  If (p(3) <> 0) Then Call ModifyLeft(p(3), ID_Decrease)  
  If (p(5) <> 0) Then Call ModifyRight(p(5), ID_Decrease)  
  If (p(7) <> 0) Then Call ModifyBottom(p(7), ID_Decrease) 

  mTLy = TLy + mTLy1 + mTLy2
  mTRy = TRy + mTRy1 + mTRy2
  mTLx = TLx + mTLx1 + mTLx2
  mTRx = TRx + mTRx1 + mTRx2
  mBLy = BLy + mBLy1 + mBLy2  
  mBRy = BRy + mBRy1 + mBRy2  
  mBLx = BLx + mBLx1 + mBLx2 
  mBRx = BRx + mBRx1 + mBRx2 

  Select Case Lcase(p(8))
    Case "front"
      mWPmod = "1"
    Case "back"
      mWPmod = "0"
    Case OneSpace
      mWPmod = WPmod
    Case Else    
  End Select

End Sub


' *************************************************
' ***
' ***  position amendment routines
' ***
' *************************************************


Sub ModifyTop(percent, id) 
  If (id = ID_Increase) Then 
    mTLy1 = Cint((TLy - BLy)/2 /100 *percent)
    mTRy1 = Cint((TRy - BRy)/2 /100 *percent)
    mTLx1 = Cint((TLx - BLx)/2 /100 *percent)
    mTRx1 = Cint((TRx - BRx)/2 /100 *percent)
  Else
    mTLy1 = - Cint((TLy - BLy)/2 /100 *percent)
    mTRy1 = - Cint((TRy - BRy)/2 /100 *percent)
    mTLx1 = - Cint((TLx - BLx)/2 /100 *percent)
    mTRx1 = - Cint((TRx - BRx)/2 /100 *percent)
  End If
End Sub


Sub ModifyLeft(percent, id)
  If (id = ID_Increase) Then
    mTLx2 = Cint((TLx - TRx)/2 /100 *percent)  
    mBLx2 = Cint((BLx - BRx)/2 /100 *percent) 
    mTLy2 = Cint((TLy - TRy)/2 /100 *percent)
    mBLy2 = Cint((BLy - BRy)/2 /100 *percent)
  Else
    mTLx2 = - Cint((TLx - TRx)/2 /100 *percent)  
    mBLx2 = - Cint((BLx - BRx)/2 /100 *percent) 
    mTLy2 = - Cint((TLy - TRy)/2 /100 *percent)
    mBLy2 = - Cint((BLy - BRy)/2 /100 *percent) 
  End If  
End Sub


Sub ModifyRight(percent, id)
  If (id = ID_Increase) Then
    mTRx2 = Cint((TRx - TLx)/2 /100 *percent)  
    mBRx2 = Cint((BRx - BLx)/2 /100 *percent) 
    mTRy2 = Cint((TRy - TLy)/2 /100 *percent)
    mBRy2 = Cint((BRy - BLy)/2 /100 *percent) 
  Else
    mTRx2 = - Cint((TRx - TLx)/2 /100 *percent)  
    mBRx2 = - Cint((BRx - BLx)/2 /100 *percent) 
    mTRy2 = - Cint((TRy - TLy)/2 /100 *percent)
    mBRy2 = - Cint((BRy - BLy)/2 /100 *percent) 
  End If 
End Sub


Sub ModifyBottom(percent, id)
  If (id = ID_Increase) Then
    mBLy1 = Cint((BLy - TLy)/2 /100 *percent)  
    mBRy1 = Cint((BRy - TRy)/2 /100 *percent)  
    mBLx1 = Cint((BLx - TLx)/2 /100 *percent)  
    mBRx1 = Cint((BRx - TRx)/2 /100 *percent)
  Else
    mBLy1 = - Cint((BLy - TLy)/2 /100 *percent)  
    mBRy1 = - Cint((BRy - TRy)/2 /100 *percent)  
    mBLx1 = - Cint((BLx - TLx)/2 /100 *percent)  
    mBRx1 = - Cint((BRx - TRx)/2 /100 *percent)
  End If  
End Sub
  

' ******************************************************************************** 
' ***
' *** read the shield parameters file ("WeaponParms.txt")
' ***
' ******************************************************************************** 


Sub ReadWeaponParms(thispath, thisfile)  
  Dim i, temp, tempspace, tempparms, filepath, copyfrom, perclist, parms
  Dim temp2, filename, camangle
  Dim IT, IL, IR, IB, DT, DL, DR, DB, WP
  Dim NOparms

  If (Not fso.FileExists(OurPath & "\WeaponParms.txt")) Then
    MsgBox "Error : File not found - " & thisfile 
    Wscript.Quit
  End If 
  
  Call ReadTxtFile(thispath & thisfile) 

  temp = split(TxtFileArray(0), "=")
  tempspace = split(TxtFileArray(0), OneSpace)
  If (Lcase(temp(0)) <> "copyfrom") Then
    MsgBox "Error : Expected 'CopyFrom=', received  - " & tempspace(0) 
    Wscript.Quit
  Else
    copyfrom = temp(1)
    copyfrom = Replace(copyfrom, "(", "")
    copyfrom = Replace(copyfrom, ")", "")
  End If
  CopyPath = OurPath & "\" & copyfrom


  'temp = split(TxtFileArray(1), "=")
  'tempspace = split(TxtFileArray(1), OneSpace)
  'If (Lcase(temp(0)) <> "normaliseshield") Then
  '  MsgBox "Error : Expected 'NormaliseShield=', received  - " & temp(0) 
  '  Wscript.Quit
  'Else
  '  Select Case Lcase(temp(1))
  '    Case "yes"
  '      NormShield = True  
  '    Case "no"
  '      NormShield = False  
  '    Case Else
  '      MsgBox "Error : Invalid 'NormaliseShield=' parameter - " & temp(1) 
  '      Wscript.Quit
  '  End Select    
  'End If

   
  For i = 1 to Ubound(TxtFileArray)-1
    temp = TxtFileArray(i)
    temp = Replace(temp, OneSpace, "=")
    temp = Split(temp, "=")
    tempspace = split(TxtFileArray(i), OneSpace)

    If (Lcase(temp(0)) <> "filecam") Then
      MsgBox "Error : Expected 'FileCam=', received  - " & tempspace(0) 
      Wscript.Quit
    End If 
   
    temp2 = temp(1)
    temp2 = Replace(temp2, "(", "")
    temp2 = Replace(temp2, ")", "")
    temp2 = Split(temp2, ",")
    filename = temp2(0) & ".txt"
    camangle = temp2(1) 

    If (Not fso.FileExists(CopyPath & "\" & filename)) Then   
      MsgBox "Error : File not found - " & CopyPath & "\" & filename 
      Wscript.Quit
    Else
      If (Not FileDic.Exists(filename)) Then
        FileDic.Add filename, OneSpace
      End If  
    End If   
 
    If (camangle = "1") or (camangle = "2") or (camangle = "3") or (camangle = "4") Then
    Else
      MsgBox "Error : Invalid camera angle specified - " & camangle 
      Wscript.Quit
    End If

    If (Not fso.FileExists(OurPath & "\" & copyfrom & "\" & filename)) Then   
      MsgBox "Error : 'CopyFile=' File not found - " & OurPath & "\" & copyfrom & "\" & filename 
      Wscript.Quit
    End If

    IT = "0"  : IL = "0"  : IR = "0"  : IB = "0"  
    DT = "0"  : DL = "0"  : DR = "0"  : DB = "0"    
    
    parms = TxtFileArray(i) & OneSpace

    NOparms = ExtractKeywordParms(parms, "NewOrigin=", OneSpace, "")
    If (NOparms <> "") Then NOparms = ExtractNOParms(Noparms, filename)   

    IT = ExtractKeywordParms(parms, "IncTop=", PercSign, "0")
    IL = ExtractKeywordParms(parms, "IncLeft=", PercSign, "0")      
    IR = ExtractKeywordParms(parms, "IncRight=", PercSign, "0")          
    IB = ExtractKeywordParms(parms, "IncBottom=", PercSign, "0") 
    DT = ExtractKeywordParms(parms, "DecTop=", PercSign, "0")
    DL = ExtractKeywordParms(parms, "DecLeft=", PercSign, "0")      
    DR = ExtractKeywordParms(parms, "DecRight=", PercSign, "0")          
    DB = ExtractKeywordParms(parms, "DecBottom=", PercSign, "0")
    WP = ExtractKeywordParms(parms, "Weapon=", OneSpace, OneSpace)

    If (Not IsNumeric(IT)) Then Call NotANumber(IT, "IncTop=", filename)
    If (Not IsNumeric(IL)) Then Call NotANumber(IL, "IncLeft=", filename)      
    If (Not IsNumeric(IR)) Then Call NotANumber(IR, "IncRight=", filename)          
    If (Not IsNumeric(IB)) Then Call NotANumber(IB, "IncBottom=", filename) 
    If (Not IsNumeric(DT)) Then Call NotANumber(DT, "DecTop=", filename)
    If (Not IsNumeric(DL)) Then Call NotANumber(DL, "DecLeft=", filename)      
    If (Not IsNumeric(DR)) Then Call NotANumber(DR, "DecRight=", filename)          
    If (Not IsNumeric(DB)) Then Call NotANumber(DB, "DecBottom=", filename)   
    
    If (IT <> "0") and (DT <> "0") Then
      MsgBox "Error : both 'IncTop=' and 'DecTop=' specified for - " & filename 
      Wscript.Quit
    End If 
    If (IL <> "0") and (DL <> "0") Then
      MsgBox "Error : both 'IncLeft=' and 'DecLeft=' specified for - " & filename 
      Wscript.Quit
    End If 
    If (IR <> "0") and (DR <> "0") Then
      MsgBox "Error : both 'IncRight=' and 'DecRight=' specified for - " & filename 
      Wscript.Quit
    End If 
    If (IB <> "0") and (DB <> "0") Then
      MsgBox "Error : both 'IncBottom=' and 'DecBottom=' specified for - " & filename 
      Wscript.Quit
    End If

    Select Case Lcase(WP)
      Case "front", "back", OneSpace
      Case Else
       MsgBox "Error : the keyword 'Weapon=' is invalid - " & WP 
       Wscript.Quit
    End Select   

    perclist =            IT & "," & DT & "," & IL & "," & DL & "," 
    perclist = perclist & IR & "," & DR & "," & IB & "," & DB & "," & WP 
    If (Not ParmsDic.Exists(filename & "," & camangle)) Then
      ParmsDic.Add filename & "," & camangle, perclist      
      If (NOparms <> "0,0,0,0") and (NOparms <> "") Then   
        OriginDic.Add filename & "," & camangle, NOparms 
      End If 
    End If    
    
  Next
 Call Showdic(OriginDic,"OriginDic")
 Call Showdic(ParmsDic,"ParmsDic")
 Call Showdic(FileDic,"FileDic")
 
End Sub


Function ExtractNOParms(parms, filename)
  Dim temp, up, down, left, right
  up = 0
  down = 0
  left = 0
  right = 0 
  temp = Replace(parms, "(", "")
  temp = Replace(temp, ")", "")
  temp = Split(temp, ",")
  Select Case Ubound(temp)
    Case 1
      If (Not IsNumeric(temp(1))) Then Call NotANumber(temp(1), "NewOrigin=", filename)      
      Select Case Lcase(temp(0))
        Case "up"
          up = temp(1)
        Case "down"
          down = temp(1)
        Case "left"
          left = temp(1)
        Case "right"
          right = temp(1)
        Case Else 
          MsgBox "Error : 'NewOrigin=' parameter is not up/down/left/right - " & temp(0) 
          Wscript.Quit
      End Select
    Case 3
      If (Not IsNumeric(temp(1))) Then Call NotANumber(temp(1), "NewOrigin=", filename) 
      If (Not IsNumeric(temp(3))) Then Call NotANumber(temp(3), "NewOrigin=", filename) 
      Select Case Lcase(temp(0))
        Case "up"
          up = temp(1)
        Case "down"
          down = temp(1)      
        Case Else 
          MsgBox "Error : 'NewOrigin=' parameter is not up/down - " & temp(0) 
          Wscript.Quit
      End Select
      Select Case Lcase(temp(2))        
        Case "left"
          left = temp(3)
        Case "right"
          right = temp(3)
        Case Else
          MsgBox "Error : 'NewOrigin=' parameter is not left/right - " & temp(0) 
          Wscript.Quit 
      End Select      
    Case Else      
      MsgBox "Error : invalid number of 'NewOrigin=' parameters specified - '" & parms & "' for - " & filename 
      Wscript.Quit
  End Select
  ExtractNOParms = up & "," & down & "," & left & "," & right
End Function


Sub NotANumber(value, parm, filename)
  MsgBox "Error : None-Numeric parameter (" & value & ") specified in '" & parm & "' for - " & filename 
  Wscript.Quit
End Sub


' ******************************************************************************** 
' ***
' *** write the action parameters file 
' ***
' ******************************************************************************** 


Sub WritePositionsFile(thispath, thisfile)  
  Dim i, temp, filepath, line

  If (fso.FileExists(thispath & thisfile)) Then
    fso.DeleteFile(thispath & thisfile)
  End If 

  filepath = thispath & thisfile 
  Set MyFile = fso.OpenTextFile(filepath, ForAppending, True)
  For i = 1 to 48
    line = TxtFileArray(i - 1)    
    MyFile.Writeline line     
  Next
  
  MyFile.Close     
End Sub

' ******************************************************************************** 
' ***
' *** read the action parameters file 
' ***
' ******************************************************************************** 


Sub ReadPositionsFile(thispath, thisfile)  
  Dim i, temp, filepath
  
  Call ReadTxtFile(thispath & thisfile)

  If (Ubound(TxtFileArray) <> 48) Then     
    MsgBox "Error : file (" & thisfile & ") does NOT contain 48 lines but - " & Ubound(TxtFileArray) & " lines!" 
    Wscript.Quit
  End If
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i))
    If (Ubound(temp) <> 4) Then     
      MsgBox "Error : None numeric value in file - " & thisfile 
      Wscript.Quit
    End If
  Next 
End Sub

' ***
' *** extract the parameters pertaining to a keyword from a string
' ***

Function ExtractKeywordParms(instring, searchstring, endstring, notfound)
  Dim startpos, endpos, lenstring, copystring  
  ExtractKeywordParms = notfound
  copystring = Lcase(instring)
  startpos = InStr(copystring, Lcase(searchstring)) 
  If (startpos <> 0) Then
    startpos = startpos + Len(searchstring) 
    endpos = InStr(startpos, copystring, endstring)
    If (endpos <> 0) Then
      lenstring = endpos - startpos   
      ExtractKeywordParms = Mid(instring, startpos, lenstring)
    End If 
  End If  
End Function


' ******************************************************************************** 
' ***
' *** Reads a text file into the array TxtFileArray
' *** 
' ******************************************************************************** 


Sub ReadTxtFile(filename)
  Dim i, line  
  Set MyFile = fso.OpenTextFile(filename, ForReading) 
  Redim TxtFileArray(0) 
  i = 0
  Do While Not MyFile.AtEndOfStream
    line = MyFile.ReadLine
    line = Replace(line, vbTab, OneSpace)
    While Instr(line, "  ")
      line = Replace(line, "  ", OneSpace)
    Wend
    If (line <> OneSpace) and (line <> "") Then 
      line = Trim(line)
      If Left(line, 2) <> "//" Then     ' ignore comments  
        Redim Preserve TxtFileArray(i+1) 
        TxtFileArray(i) = line
        i = i + 1
      End If
    End If 
  Loop  
  MyFile.Close 
End Sub 


' *************************************************
' ***
' *** Other required subs
' ***
' *************************************************

' ***
' *** Get our (ie: this folders!) pathname1
' ***

Function GetLocalDirectory() 
  Const sMe = "[GetLocalDirectory], "
  Dim iFile  ' as integer
  ' find the LAST backslash...
  iFile = InStrRev(Wscript.ScriptFullName, "\")
  BugAssert (iFile > 0), sMe & " file path problem "  ' if backslash not found...
  ' get the path to this script...
  GetLocalDirectory = Left(Wscript.ScriptFullName, iFile)  ' path (inc "\")... 
End Function

' ***
' *** for critical errors
' ***

Sub BugAssert (bTest, sErrMsg)
  If (bTest) then Exit Sub
  MsgBox "Error Detected by BugAssert: " & vbCr & vbCr & sErrMsg, vbCritical, _ 
  " << BugAssert FAILED >> "
  WScript.Quit
End Sub

' ***
' *** show a dictionary - just for debugging
' ***

Sub ShowDic(thisdic, title)          ' debugging - display built dictionary
  Dim i, a1, a2, a3
  a1 = thisdic.Keys 
  a2 = thisdic.Items
  For i = 0 To thisdic.Count -1 ' Iterate the array.
    a3 = a3  & a1(i) & "  " & a2(i) & vbcrlf
  Next
  Wscript.echo title,vbcrlf,a3
End Sub


